
// Simple test of ABI (depends on OS)
// gcc -c -O2 ijc-abi-test.c    // -march=native
// objdump -d

int f(int a, int b, int c, int d, int e, int f, int g, int h) {
    return a+b+c+d+e+f+g+h;
}

double g(double a, double b, double c, double d, double e, double f, double g, double h) {
    return a+b+c+d+e+f+g+h;
}

// test
int main() {
    int i = f(1,2,3,4,5,6,7,8);
    double x = g(1,2,3,4,5,6,7,8);
    return i+x;
}

//==================================================================
//abi-test.o:     file format elf64-x86-64
//Disassembly of section .text:
//
//0000000000000000 <f>:  // PARAMS: 6 in registers + 2 on stack
//   0: 8d 3c 3e                lea    (%rsi,%rdi,1),%edi
//   3: 8d 14 17                lea    (%rdi,%rdx,1),%edx
//   6: 01 ca                   add    %ecx,%edx
//   8: 44 01 c2                add    %r8d,%edx
//   b: 42 8d 04 0a             lea    (%rdx,%r9,1),%eax
//   f: 03 44 24 08             add    0x8(%rsp),%eax
//  13: 03 44 24 10             add    0x10(%rsp),%eax
//  17: c3                      retq
//
//0000000000000020 <g>:  // PARAMS: 8 in registers
//  20: f2 0f 58 c1             addsd  %xmm1,%xmm0
//  24: f2 0f 58 c2             addsd  %xmm2,%xmm0
//  28: f2 0f 58 c3             addsd  %xmm3,%xmm0
//  2c: f2 0f 58 c4             addsd  %xmm4,%xmm0
//  30: f2 0f 58 c5             addsd  %xmm5,%xmm0
//  34: f2 0f 58 c6             addsd  %xmm6,%xmm0
//  38: f2 0f 58 c7             addsd  %xmm7,%xmm0
//  3c: c3                      retq
//
//0000000000000040 <main>:
//  40: b8 48 00 00 00          mov    $0x48,%eax       // optimized
//  45: c3                      retq

//==================================================================
//abi-test.o:     file format elf32-i386
//Disassembly of section .text:
//
//00000000 <f>:
//   0: 55                      push   %ebp
//   1: 89 e5                   mov    %esp,%ebp
//   3: 8b 45 0c                mov    0xc(%ebp),%eax
//   6: 03 45 08                add    0x8(%ebp),%eax
//   9: 03 45 10                add    0x10(%ebp),%eax
//   c: 03 45 14                add    0x14(%ebp),%eax
//   f: 03 45 18                add    0x18(%ebp),%eax
//  12: 03 45 1c                add    0x1c(%ebp),%eax
//  15: 03 45 20                add    0x20(%ebp),%eax
//  18: 03 45 24                add    0x24(%ebp),%eax
//  1b: 5d                      pop    %ebp
//  1c: c3                      ret
//
//00000020 <g>:
//  20: 55                      push   %ebp
//  21: 89 e5                   mov    %esp,%ebp
//  23: dd 45 10                fldl   0x10(%ebp)
//  26: dc 45 08                faddl  0x8(%ebp)
//  29: dc 45 18                faddl  0x18(%ebp)
//  2c: dc 45 20                faddl  0x20(%ebp)
//  2f: dc 45 28                faddl  0x28(%ebp)
//  32: dc 45 30                faddl  0x30(%ebp)
//  35: dc 45 38                faddl  0x38(%ebp)
//  38: dc 45 40                faddl  0x40(%ebp)
//  3b: 5d                      pop    %ebp
//  3c: c3                      ret
//
//00000040 <main>:
//  40: 55                      push   %ebp
//  41: b8 48 00 00 00          mov    $0x48,%eax
//  46: 89 e5                   mov    %esp,%ebp
//  48: 5d                      pop    %ebp
//  49: c3                      ret

//==================================================================
//ijc-abi-test.o:     file format elf64-x86-64 (Ryzen, -march=native)
//0000000000000000 <f>:
//   0:   01 f7                   add    %esi,%edi
//   2:   8b 44 24 08             mov    0x8(%rsp),%eax
//   6:   01 d7                   add    %edx,%edi
//   8:   01 cf                   add    %ecx,%edi
//   a:   44 01 c7                add    %r8d,%edi
//   d:   44 01 cf                add    %r9d,%edi
//  10:   01 f8                   add    %edi,%eax
//  12:   03 44 24 10             add    0x10(%rsp),%eax
//  16:   c3                      retq
//
//0000000000000020 <g>:
//  20:   c5 fb 58 c1             vaddsd %xmm1,%xmm0,%xmm0
//  24:   c5 fb 58 c2             vaddsd %xmm2,%xmm0,%xmm0
//  28:   c5 fb 58 c3             vaddsd %xmm3,%xmm0,%xmm0
//  2c:   c5 fb 58 c4             vaddsd %xmm4,%xmm0,%xmm0
//  30:   c5 fb 58 c5             vaddsd %xmm5,%xmm0,%xmm0
//  34:   c5 fb 58 c6             vaddsd %xmm6,%xmm0,%xmm0
//  38:   c5 fb 58 c7             vaddsd %xmm7,%xmm0,%xmm0
//  3c:   c3                      retq
//
//0000000000000000 <main>:
//   0:   b8 48 00 00 00          mov    $0x48,%eax
//   5:   c3                      retq
//==================================================================
