
#include <stdio.h>
#include <limits.h>

#define PRINT_SIZEOF(x) printf("sizeof(" #x ") = %d\n", sizeof(x));

int main()
{
    int bits = sizeof(void *) * CHAR_BIT;
    printf("%dbit architecture\n", bits);
    if (sizeof(void *) == sizeof(int))
        printf("ILP%d\n", bits);        // FIXME: problem int32 long64 ptr32
    else if (sizeof(void *) == sizeof(long))
        printf("LP%d\n", bits);
    else if (sizeof(void *) == sizeof(long long))
        printf("LLP%d\n", bits);
    PRINT_SIZEOF(void *);
    PRINT_SIZEOF(char);
    PRINT_SIZEOF(short);
    PRINT_SIZEOF(int);
    PRINT_SIZEOF(long);
    PRINT_SIZEOF(long long);
    PRINT_SIZEOF(float);
    PRINT_SIZEOF(double);
    PRINT_SIZEOF(long double);
    return 0;
}
